Subject: [IPP] Update registration for "printer-current-time" Printer Description attribute in IANA Registry; was Re: Minutes posted from today's concall

From: "Kennedy, Smith \(Wireless & IPP Standards\) via ipp" <[email-masked]>
Date: Mon, 26 Oct 2020 20:35:50 +0000

Hi Mike,

In the minutes from this meeting, on page 3, it says in the minutes from reviewing IPP Driverless Printing Extensions v2.0:

⁃ Sections 6.7.3/6.7.4:
    ⁃ Make REQUIRED (required for IPP Everywhere)
    ⁃ STD92 reference for printer-current-time and printer-up-time
    ⁃ Fix IANA registry for printer-current-time (dateTime|unknown)
    ⁃ "printer-config-change-date-time (dateTime|unknown)"
    ⁃ Discuss potential "unknown" value for date-time (copied from printer-current-time)

I'm not sure we have this resolved yet:

    ⁃ Fix IANA registry for printer-current-time (dateTime|unknown)

In looking at the IANA IPP registry, I see these two entries for "printer-current-time":

Event Notifications		printer-current-time		dateTime|unknown		[RFC3996]
Printer Description		printer-current-time		dateTime				[RFC8011]

We have to update the second one because RFC 8011 defines it thus:

5.4.30.  printer-current-time (dateTime|unknown)

Should I be filing a bug on https://github.com/istopwg/ippregistry/ <https://github.com/istopwg/ippregistry/> ?

Smith

/**
    Smith Kennedy
    HP Inc.
*/

> On Mar 12, 2020, at 2:36 PM, Michael Sweet via ipp <[email-masked]> wrote:
> 
> All,
> 
> I have posted the minutes from today's IPP workgroup conference call to:
> 
> https://ftp.pwg.org/pub/pwg/ipp/minutes/ippv2-concall-minutes-20200312.pdf <https://ftp.pwg.org/pub/pwg/ipp/minutes/ippv2-concall-minutes-20200312.pdf>
> 
> Our next meeting is on March 26, 2020 at 3pm EDT.
> 
> ________________________
> Michael Sweet
> 
> 
> 
> _______________________________________________
> ipp mailing list
> [email-masked]
> https://www.pwg.org/mailman/listinfo/ipp <https://www.pwg.org/mailman/listinfo/ipp>

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp

---

From: Michael Sweet via ipp <[email-masked]>
Date: Mon, 26 Oct 2020 17:04:13 -0400

Smith,

> On Oct 26, 2020, at 4:35 PM, Kennedy, Smith (Wireless & IPP Standards) <[email-masked]> wrote:
> ...
> Should I be filing a bug on https://github.com/istopwg/ippregistry/ ?

No, I've added it to my local list of changes for the registry (I'll apply it with the media obsoletions...)

>> https://ftp.pwg.org/pub/pwg/ipp/minutes/ippv2-concall-minutes-20200312.pdf
>> 

________________________
Michael Sweet

---

From: Ira McDonald via ipp <[email-masked]>
Date: Mon, 26 Oct 2020 20:34:35 -0400

Hi,

The lack of REQUIRED "printer-current-time" to populate "date-time-at-xxx"
attributes is an *old* problem - noticed in the first draft of IPP 2.0.  In
RFC
8011, it's still (incorrectly) RECOMMENDED, which breaks the preferred
"date-time-at-xxx" attributes (the only useful ones in a Job Log) - and RFC
8011 is the authoritative source definition in the IANA IPP Registry, so
this
can't simply be fixed in a PWG 5100.x spec (I think?).

WDYT?

Cheers,
- Ira

*Ira McDonald (Musician / Software Architect)*

*Chair - SAE Trust Anchors and Authentication TF*
*Co-Chair - TCG Trusted Mobility Solutions WG*

*Co-Chair - TCG Metadata Access Protocol SG*

*Chair - Linux Foundation Open Printing WGSecretary - IEEE-ISTO Printer
Working GroupCo-Chair - IEEE-ISTO PWG Internet Printing Protocol WGIETF
Designated Expert - IPP & Printer MIBBlue Roof Music / High North
Inchttp://sites.google.com/site/blueroofmusic
<http://sites.google.com/site/blueroofmusic>http://sites.google.com/site/highnorthinc
<http://sites.google.com/site/highnorthinc>mailto: [email-masked]
<[email-masked]>(permanent) PO Box 221  Grand Marais, MI 49839
906-494-2434*

---

From: Michael Sweet via ipp <[email-masked]>
Date: Mon, 26 Oct 2020 21:09:13 -0400

Ira,

> On Oct 26, 2020, at 8:34 PM, Ira McDonald <[email-masked]> wrote:
> 
> Hi,
> 
> attributes is an *old* problem - noticed in the first draft of IPP 2.0.  In RFC
> 8011 is the authoritative source definition in the IANA IPP Registry, so this

So dateTime attributes were all optional in IPP/1.1 and IPP/2.0.  And we updated the definition of printer-current-time to include the 'unknown' syntax since it was already explicitly allowed in RFC 2911, just not included in the syntax definition for printer-current-time...

The issue for the registry is that when I updated the registrations for RFC 8011 I didn't update the printer-current-time syntax to match the document.  I'll include a fix for that in my next dump for IANA.

The issue for IPP Everywhere is that 1.0 didn't explicitly require it but *did* require date-time-at-xxx - clearly the intent was to require printer-current-time but we missed it.  IPP Everywhere 1.1 makes it RECOMMENDED and notes that the omission from 1.0 was an error since we *did* require date-time-at-xxx.  IPP Everywhere 2.0 will be able to make it REQUIRED.

Anyways...

________________________
Michael Sweet

---

From: Ira McDonald via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 11:22:47 -0400

Hi Mike,

About where we RECOMMEND or REQUIRE the "date-time" attributes:

In eventual IPP/2.x update, I suggest that IPP/2.1 (Enterprise) and
IPP/2.2 (Production) should REQUIRE the "date-time" attributes (since
this will after all be a major update to the previous PWG Standard of
IPP/2.x).

Rick Landau (Dell) and I ran up against this issue way back when we
were doing mappings to DMTF CIM classes (where real date-time was
already ubiquitous).

WDYT?

Cheers,
- Ira

On Mon, Oct 26, 2020 at 9:09 PM Michael Sweet <[email-masked]> wrote:

> So dateTime attributes were all optional in IPP/1.1 and IPP/2.0.  And we
> updated the definition of printer-current-time to include the 'unknown'
> syntax since it was already explicitly allowed in RFC 2911, just not
> included in the syntax definition for printer-current-time...
>
> The issue for the registry is that when I updated the registrations for
> RFC 8011 I didn't update the printer-current-time syntax to match the
> document.  I'll include a fix for that in my next dump for IANA.
>
> The issue for IPP Everywhere is that 1.0 didn't explicitly require it but
> *did* require date-time-at-xxx - clearly the intent was to require
> printer-current-time but we missed it.  IPP Everywhere 1.1 makes it
> RECOMMENDED and notes that the omission from 1.0 was an error since we
> *did* require date-time-at-xxx.  IPP Everywhere 2.0 will be able to make it
> REQUIRED.
>
> Anyways...
>
> ________________________
> Michael Sweet
>
>
>
>

---

From: "Kennedy, Smith \(Wireless & IPP Standards\) via ipp" <[email-masked]>
Date: Tue, 27 Oct 2020 15:52:06 +0000

Hi Ira,

I think all 2.x levels should REQUIRE the "date-time-at-xxx" and "printer-current-time", since any printers that have an un-initialized clock can always use the 'unknown' out-of-band value, to reduce the variability between levels. Even basic printers ought to be able to do that at this point if they are implementing IPP, don't you think?

Smith

/**
    Smith Kennedy
    HP Inc.
*/

> On Oct 27, 2020, at 9:22 AM, Ira McDonald <[email-masked]> wrote:
> 
> Hi Mike,
> 
> Ira McDonald (Musician / Software Architect)
> Chair - SAE Trust Anchors and Authentication TF
> Co-Chair - TCG Trusted Mobility Solutions WG
> Co-Chair - TCG Metadata Access Protocol SG
> Chair - Linux Foundation Open Printing WG
> Secretary - IEEE-ISTO Printer Working Group
> Co-Chair - IEEE-ISTO PWG Internet Printing Protocol WG
> IETF Designated Expert - IPP & Printer MIB
> Blue Roof Music / High North Inc
> http://sites.google.com/site/blueroofmusic <http://sites.google.com/site/blueroofmusic>
> http://sites.google.com/site/highnorthinc <http://sites.google.com/site/highnorthinc>
> mailto: [email-masked] <mailto:[email-masked]>
> (permanent) PO Box 221  Grand Marais, MI 49839  906-494-2434
> 
> 
> On Mon, Oct 26, 2020 at 9:09 PM Michael Sweet <[email-masked] <mailto:[email-masked]>> wrote:
> Ira,
> 
> > On Oct 26, 2020, at 8:34 PM, Ira McDonald <[email-masked] <mailto:[email-masked]>> wrote:
> >
> > Hi,
> >

---

From: Michael Sweet via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 13:31:15 -0400

Smith,

IPP 2.1 and 2.2 require the dateTime attributes.  IPP 2.0 doesn't, and we can't really change that for IPP 2.0 since the versioning is pretty well hardcoded (a good reason never to do that again... :)

> On Oct 27, 2020, at 11:52 AM, Kennedy, Smith (Wireless & IPP Standards) <[email-masked]> wrote:
> 
> Hi Ira,
> 
>> http://sites.google.com/site/blueroofmusic
>> http://sites.google.com/site/highnorthinc
>> mailto: [email-masked]

________________________
Michael Sweet

---

From: Ira McDonald via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 15:07:10 -0400

Hi Mike,

In the PWG Standard 5100.12-2015, *none* of the "date-time-xxx" attributes
are
listed at any level (2.0, 2.1, or 2.2) - I just searched for them again.

We could at least make them RECOMMENDED at all three version levels and
continue to make them REQUIRED in IPP Everywhere, right?

Cheers,
- Ira

On Tue, Oct 27, 2020 at 1:31 PM Michael Sweet <[email-masked]> wrote:

> Smith,
>
> IPP 2.1 and 2.2 require the dateTime attributes.  IPP 2.0 doesn't, and we
> can't really change that for IPP 2.0 since the versioning is pretty well
> hardcoded (a good reason never to do that again... :)
>
>
> > I think all 2.x levels should REQUIRE the "date-time-at-xxx" and
> "printer-current-time", since any printers that have an un-initialized
> clock can always use the 'unknown' out-of-band value, to reduce the
> variability between levels. Even basic printers ought to be able to do that
> at this point if they are implementing IPP, don't you think?
> >
> > Smith
> >
> > /**
> >     Smith Kennedy
> >     HP Inc.
> > */
> >
> >> So dateTime attributes were all optional in IPP/1.1 and IPP/2.0.  And
> we updated the definition of printer-current-time to include the 'unknown'
> >> The issue for IPP Everywhere is that 1.0 didn't explicitly require it
> but *did* require date-time-at-xxx - clearly the intent was to require

---

From: "Kennedy, Smith \(Wireless & IPP Standards\) via ipp" <[email-masked]>
Date: Tue, 27 Oct 2020 19:09:31 +0000

Sorry, I should have been more clear that I was suggesting we should update the normative requirements to make all levels (if we have levels) REQUIRE the "date-time-at-xxx" and "printer-current-time" whenever we decide to create an "IPP/3".

> On Oct 27, 2020, at 11:31 AM, Michael Sweet <[email-masked]> wrote:
> 
> Smith,
>

---

From: Ira McDonald via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 15:14:46 -0400

Hi Smith,

Thanks for the clarification.

Mike has been suggesting for some time that we should never create any more
numbered versions of IPP.  Instead, we should use "ipp-features-supported"
and
"[format]-features-supported" for better clarity.  I agree with Mike.

Cheers,
- Ira

On Tue, Oct 27, 2020 at 3:09 PM Kennedy, Smith (Wireless & IPP Standards) <
[email-masked]> wrote:

> Sorry, I should have been more clear that I was suggesting we should
> update the normative requirements to make all levels (if we have levels)
> REQUIRE the "date-time-at-xxx" and "printer-current-time" whenever we
> decide to create an "IPP/3".
>
>

---

From: Michael Sweet via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 17:36:08 -0400

Ira,

Sigh, yes it looks like we basically took a pass on all of the dateTime attributes, so yes the best we can do for those versions is to add a  bunch of recommended stuff.  But then I think a lot of IPP 2.x is in that boat anyways so why not more?

> On Oct 27, 2020, at 3:07 PM, Ira McDonald <[email-masked]> wrote:
> 
> Hi Mike,
> 
> In the PWG Standard 5100.12-2015, *none* of the "date-time-xxx" attributes are

________________________
Michael Sweet

---

From: Ira McDonald via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 17:51:28 -0400

Hi Mike,

Thanks.

So should we move all the dateTime attributes up to RECOMMENDED for all
three levels
of IPP 2.0, 2.1, 2.2 in our revision later in 2021?

Cheers,
- Ira

On Tue, Oct 27, 2020 at 5:36 PM Michael Sweet <[email-masked]> wrote:

> Ira,
>
> Sigh, yes it looks like we basically took a pass on all of the dateTime
> attributes, so yes the best we can do for those versions is to add a  bunch
> of recommended stuff.  But then I think a lot of IPP 2.x is in that boat
> anyways so why not more?
>
>
> > IPP 2.1 and 2.2 require the dateTime attributes.  IPP 2.0 doesn't, and
> we can't really change that for IPP 2.0 since the versioning is pretty well
> > >> The issue for the registry is that when I updated the registrations
> for RFC 8011 I didn't update the printer-current-time syntax to match the

---

From: Michael Sweet via ipp <[email-masked]>
Date: Tue, 27 Oct 2020 17:54:45 -0400

Ira,

Yes, and I have a feeling there will be others... :/

> On Oct 27, 2020, at 5:51 PM, Ira McDonald <[email-masked]> wrote:
> 
> Hi Mike,
> 
> Thanks.
> 
> So should we move all the dateTime attributes up to RECOMMENDED for all three levels

________________________
Michael Sweet